'SIDstick Player V1.3 by Jeff Ledger / Oldbitcollector

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    

nxxt = 14
prev = 15
play = 16
vol  = 0

VAR
  byte buffer[25]
  byte filename[18]
  byte fileNumber
  long waitTime
  long playRate
    
OBJ
  SID : "SIDCog"  
  SD  : "fsrw"
   
PUB Main  | volume, counter, time

  SID.start(26,27) 
                                                    
  sd.mount_explicit(20, 19, 18, 17)      
  fileNumber := -1
  volume:=1
  counter:=0

  '' Setup counter for RCdelay read for volume control
  ctra[30..26] := %01000                 ' Set mode to "POS detector"
  ctra[5..0] := vol                     
  frqa := 1                              ' Increment phsa by 1 for each clock tick
  
  repeat
     dira[vol] := outa[vol] := 1           
     waitcnt(clkfreq/100_000 + cnt)      ' Wait for circuit to charge
      
     ' Start RC decay measurement. 
     phsa~                               ' Clear the phsa register
     dira[vol]~                          ' Pin to input stops charging circuit
     
    if( sd.pread(@buffer, 25) ) < 0
       fileNumber++
       openNextFile
  
    if ina[nxxt] == 1
      filenumber++
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      openNextFile
      
    if ina[prev] == 1
      filenumber--
      if filenumber < 0
         filenumber := 0
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      openNextFile

    if ina[play] == 1 and counter > 20
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      counter:=0
      repeat until ina[play] == 1 
      waitTime := cnt + 80_000_000/playRate    

    'Wait 1/playRate sec between updates 
    repeat until cnt-waitTime>0
    waitTime := cnt + 80_000_000/playRate
    
    'Calculate Volume from RCdelay
    time := (phsa - 624) #> 0
    volume := time/4100

    'Update SID registers 
    buffer[24]:= (buffer[24]&$F0) | (volume&$0F)
    counter++
    SID.updateRegisters( @buffer )
    
PUB openNextFile | i
    sd.opendir
    repeat i from 0 to fileNumber
        sd.nextfile( @filename )
    sd.popen( @filename, "r")
    waitTime := cnt + 10_000_000

    ' Get play rate from the SID dump file (if it contains a header)
    playRate := 50     
    if( sd.pread(@buffer, 25) ) => 0
      if buffer[0] == "S" and buffer[1] == "D" and buffer[2] == "M" and buffer[3] == "P"
        playRate := buffer[4] | (buffer[5]<<8)  
    